#include 'Appevent.ch'
#include 'Common.ch'
#include 'Gra.ch'
#include 'Xbp.ch'

*************************
PROCEDURE DbeSys ; RETURN
PROCEDURE AppSys ; RETURN 
*************************

**************
PROCEDURE Main
**************
LOCAL oDlg, nEvent, mp1, mp2, oXbp

oDlg := XbpDialog():new( , , { 0, 0 }, { 790, 600 }, { { XBP_PP_COMPOUNDNAME, '8.Arial' } }, .F. )
   oDlg:taskList                := .T.
   oDlg:border                  := XBPDLG_DLGBORDER
   oDlg:title                   := 'Test'
   oDlg:drawingArea:clipChildren:= .T.
   oDlg:create()

oXbp:= XbpStatic():new()
   oXbp:caption:= 'paint'
   oXbp:options:= XBPSTATIC_TEXT_VCENTER + XBPSTATIC_TEXT_CENTER
   oXbp:paint  := {|aRect,u,obj| MyPaint( aRect, obj ) }
   oXbp:create( oDlg:drawingArea,, { 100, 100 }, { 100, 100 }, { { XBP_PP_BGCLR, GRA_CLR_WHITE } } )

oXbp:= XbpStatic():new()
   oXbp:caption := 'ownerdraw #1'
   oXbp:drawMode:= XBP_DRAW_OWNERADVANCED
   oXbp:options := XBPSTATIC_TEXT_VCENTER + XBPSTATIC_TEXT_CENTER
   oXbp:draw    := {|oPS, aInfo| MyDraw( oPS, aInfo ) }
   oXbp:create( oDlg:drawingArea,, { 100, 250 }, { 100, 100 }, { { XBP_PP_BGCLR, GRA_CLR_WHITE } } )

oXbp:= MyXbpStatic():new()
   oXbp:caption := 'ownerdraw #2'
   oXbp:options := XBPSTATIC_TEXT_VCENTER + XBPSTATIC_TEXT_CENTER
   oXbp:create( oDlg:drawingArea,, { 100, 400 }, { 100, 100 }, { { XBP_PP_BGCLR, GRA_CLR_WHITE } } )

oDlg:setFrameState( XBPDLG_FRAMESTAT_MAXIMIZED )

SetAppFocus( oDlg )
SetAppWindow( oDlg )

DO WHILE nEvent <> xbeP_Close
   nEvent := AppEvent( @mp1, @mp2, @oXbp )
   oXbp:handleEvent( nEvent, mp1, mp2 )
ENDDO
QUIT
RETURN

********************************
PROCEDURE MyPaint( aRect, oXbp )
********************************
LOCAL oPS:= oXbp:lockPs()

oPS:setColor( GRA_CLR_BLUE )
GraBox( oPs, { 4, 4 }, { aRect[ 3 ] - 5, aRect[ 4 ] - 5 } )
oXbp:unlockPS()
RETURN

******************************
PROCEDURE MyDraw( oPS, aInfo )
******************************
oPS:setColor( GRA_CLR_RED )
GraBox( oPs, { 4, 4 }, { aInfo[ XBP_DRAWINFO_RECT, 3 ] - 5, aInfo[ XBP_DRAWINFO_RECT, 4 ] - 5 } )
RETURN

********************************
CLASS MyXbpStatic FROM XbpStatic
********************************
EXPORTED:
   INLINE METHOD Init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   *****************************************************************
      ::XbpStatic:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
         ::drawMode:= XBP_DRAW_OWNERADVANCED
   RETURN self

   INLINE METHOD Draw( oPS, aInfo )
   ********************************
     oPS:setColor( GRA_CLR_DARKGREEN )
     GraBox( oPs, { 4, 4 }, { aInfo[ XBP_DRAWINFO_RECT, 3 ] - 5, aInfo[ XBP_DRAWINFO_RECT, 4 ] - 5 } )
   RETURN .T.
ENDCLASS